package unot;

import java.io.*;
import java.util.*;

/**
 * ϥեؤΥΡɽ񤭽Ф롼Υ饹Υƥץ졼ȡ 
 */
abstract class LineWriter {

	/** 饹⤫黲Ȥȡʥ */
	public DocSet docset;
	public PrintStream out; 

	public LineWriter(DocSet docset, PrintStream out) {
		this.docset = docset;
		this.out = out;
	}

	/** Υ饤ν̾Ԥʸ֤
	 */
	abstract public String getName(); 

	/**
	 * ʸڤ꥿򣱹Ԥ˽񤭽Ф
	 */
	public void writeDocDelimitor() {
		out.println("\n@doc");
	}
		
	public void writeDocDelimitor(int docId) {
		out.println("\n@doc "+docId);
	}
		
	/** Ρɤ򣱹Ԥ˽񤭽Ф
	 * @exception IOException if an error occurs
	 */
	abstract void writeNodeLine(UnotNode node) throws IOException;

	
	//For indentation
	static final String INDENT_STRING = "  ";
	boolean useIndent = false; 

	/** Ρɤʲ̵ͭꤹ */
	public void setIndent(boolean flag) {
		this.useIndent = flag; 
	};

	/** ΡɤʲԤ */
	public void putIndent(int depth) {
		if (useIndent)
			for (int d = 0; d < depth; d++)
				out.print(INDENT_STRING);
	}

} // LineReader


//EOF 

