package unot;

import java.io.*;
import java.util.*;

/**
 * ƥΡɷϥեιɤ߹ߥ롼Υ饹.
 */
class ParentFormatLineReader extends LineReader {

	final String signature = "ParentFormatLineReader";

// 	/** 饹⤫黲Ȥȡʥ */
// 	private StreamTokenizer st; 
// 	private DocSet docset;

	public ParentFormatLineReader(DocSet docset, StreamTokenizer st) {
		super(docset, st);
	}

	String getSignature() { return signature; };
		
	/**
	 * ΡɹԤ򣱹ɤ߹ǥǡ򹹿롥
	 *
	 * @exception IOException if an error occurs
	 */
	public UnotNode readNodeLine() throws IOException
	{
		//Access UnotNode
		DocSet.NodeDict nodeDict = this.docset.getNodeDict();
		UnotNode node;

		// ʥΡֹɤ			
		if (st.ttype == StreamTokenizer.TT_NUMBER) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO,
							"@log Lookup_Node: " + (int) st.nval);

			//Access UnotNode
			//Ρֹ椫 lookupNode ǥΡɤʸ
			node = (UnotNode) nodeDict.lookupNode((int) st.nval);

		} else throw new IOException("A number token expected at self node position: "+
									 "\""+st.sval+"\"");

		// ƥΡֹɤ
		if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, " " + st.sval);

			//Access UnotNode
			UnotNode parent = nodeDict.lookupNode((int) st.nval);
			node.setParentChildRelation(parent);
			//node.setParent(parent);
			//if (parent != null) {
			//	//System.out.println("debug: parent="+parent);
			//parent.getChildren().add(node);
			//}

		} else throw new IOException("A number token expected at parent node position: "+"\""+st.sval+"\"");

		// ٥ʸ󤫤 lookupId ǥ٥ ID Ϳ
		if (st.nextToken() == StreamTokenizer.TT_WORD ||
			st.ttype == StreamTokenizer.TT_NUMBER ||
			st.ttype == '\"' || //ʸ
			st.ttype == '\'' || //ʸ
			true ) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, " " + st.sval);

			//Access UnotNode
			DocSet.LabelDict labelDict = this.docset.getLabelDict();
			node.setLabelId(labelDict.lookupId(st.sval));

		} else
			throw new IOException("A word token expected at node label position: "+"\""+st.sval+"\"");
				
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO, "\n");
		if (node == null)
			throw new IOException();

		//Access UnotNode
		return node;
	}
} // ParentFormatLineReader

